Unit AFH1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF10_p;

procedure AFH1R(var A :Array of Real; N :Integer; var IERR :Integer);

implementation

procedure AFH1R(var A :Array of Real; N :Integer; var IERR :Integer);
var
IP,IQ,IR,IP1,J,I,K :Integer;
L,X,RN :Real;
const
ONE :Real = 1.0E0;
SIXTN :Real = 16.0E0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
IP1 := 1;
RN := ONE/((N)*SIXTN);
IP := 1;
IERR := 0;
for I:=1 to N do
 begin
  IQ := IP;
  IR := 1;
  for J:=1 to I do
   begin
    X := A[IP-1];
    if ( J = 1 ) 
     then goto _2;
    for K:=IQ to IP1 do
     begin
      X := X-A[K-1]*A[IR-1];
      IR := IR+1;
_1:
     end;
_2:
    if ( I <> J ) 
     then goto _3;
    if ( A[IP-1]+X*RN <= A[IP-1] ) 
     then goto _7;
    A[IP-1] := Sqrt(X);
    goto _4;
_3:
    A[IP-1] := X/A[IR-1];
_4:
    IP1 := IP;
    IP := IP+1;
    IR := IR+1;
_5:
   end;
_6:
 end;
goto _8;
_7:
IERR := 65;
UTAF10(IERR,1);
_8:
end;

end.
